# https://sourceforge.net/projects/pyqt/files/PyQt5/PyQt-5.10.1/PyQt5_gpl-5.10.1.tar.gz
# we don't want to provide private python extension libs
%define _exclude_files_from_autoprov %{python2_sitearch}/.*\\.so\\|%{python3_sitearch}/.*\\.so
%global _disable_ld_no_undefined 1

Name:           python-qt5
Version:        5.10.1
Release:        %mkrel 1
Summary:        Set of Python bindings for Trolltech's Qt application framework

Group:          Development/Python
License:        GPLv2+
URL:            http://www.riverbankcomputing.co.uk/software/pyqt/intro
Source0:        PyQt5_gpl-%{version}.tar.xz
Source1:        pyuic5.sh

Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}

BuildRequires:  %{_lib}qt5base5-devel
BuildRequires:  %{_lib}qt5bluetooth-devel
BuildRequires:  %{_lib}qt5bootstrap-devel
BuildRequires:  %{_lib}qt5clucene-devel
BuildRequires:  %{_lib}qt5concurrent-devel
BuildRequires:  %{_lib}qt5core-devel
BuildRequires:  %{_lib}qt5dbus-devel
BuildRequires:  %{_lib}qt5designer-devel
BuildRequires:  %{_lib}qt5egldeviceintegration-devel
BuildRequires:  %{_lib}qt5gui-devel
BuildRequires:  %{_lib}qt5help-devel
BuildRequires:  %{_lib}qt5labstemplates-devel
BuildRequires:  %{_lib}qt5location-devel
BuildRequires:  %{_lib}qt5multimedia-devel
BuildRequires:  %{_lib}qt5multimediaquick_p-devel
BuildRequires:  %{_lib}qt5multimediawidgets-devel
BuildRequires:  %{_lib}qt5network-devel
BuildRequires:  %{_lib}qt5nfc-devel
BuildRequires:  %{_lib}qt5opengl-devel
BuildRequires:  %{_lib}qt5platformsupport-devel
BuildRequires:  %{_lib}qt5positioning-devel
BuildRequires:  %{_lib}qt5printsupport-devel
BuildRequires:  %{_lib}qt5qgsttools_p-devel
BuildRequires:  %{_lib}qt5qml-devel
BuildRequires:  %{_lib}qt5quick-devel
BuildRequires:  %{_lib}qt5quickparticles-devel
BuildRequires:  %{_lib}qt5quicktest-devel
BuildRequires:  %{_lib}qt5quickwidgets-devel
BuildRequires:  %{_lib}qt5script-devel
BuildRequires:  %{_lib}qt5scripttools-devel
BuildRequires:  %{_lib}qt5sensors-devel
BuildRequires:  %{_lib}qt5serialport-devel
BuildRequires:  %{_lib}qt5sql-devel
BuildRequires:  %{_lib}qt5svg-devel
BuildRequires:  %{_lib}qt5test-devel
BuildRequires:  %{_lib}qt5waylandclient-devel
BuildRequires:  %{_lib}qt5webchannel-devel
BuildRequires:  %{_lib}qt5websockets5-devel
BuildRequires:  %{_lib}qt5widgets-devel
BuildRequires:  %{_lib}qt5x11extras-devel
BuildRequires:  %{_lib}qt5xcbqpa-devel
BuildRequires:  %{_lib}qt5xml-devel
BuildRequires:  %{_lib}qt5xmlpatterns5-devel
BuildRequires:  %{_lib}qt5webkit-devel
BuildRequires:  %{_lib}qt5webkitwidgets-devel
BuildRequires:  qtbase5-common-devel
BuildRequires:  python-sip >= 4.16.6
BuildRequires:  sed
BuildRequires:  python-devel

Provides: PyQt5 = %version-%release

%rename         %{name}-core
%rename         %{name}-dbus
%rename         %{name}-bluetooth
%rename         %{name}-designer
%rename         %{name}-gui
%rename         %{name}-location
%rename         %{name}-multimedia
%rename         %{name}-multimediawidgets
%rename         %{name}-network
%rename         %{name}-nfc
%rename         %{name}-opengl
%rename         %{name}-positioning
%rename         %{name}-printsupport
%rename         %{name}-qml
%rename         %{name}-quick
%rename         %{name}-serialport
%rename         %{name}-sql
%rename         %{name}-svg
%rename         %{name}-test
%rename         %{name}-webchannel
%rename         %{name}-websockets
%rename         %{name}-widgets
%rename         %{name}-xml
%rename         %{name}-xmlpatterns
%rename         %{name}-x11extras
%rename         %{name}-quickwidgets
%rename         %{name}-sensors
%rename         %{name}-webkit
%rename         %{name}-webkitwidgets

%description
PyQt is a set of Python bindings for Trolltech's Qt application framework

%files
%doc NEWS README LICENSE
%{python2_sitelib}/*
%{python2_sitearch}/*
%{_datadir}/sip
%{_qt5_prefix}/qsci
%{_qt5_plugindir}/PyQt5

%package devel
Summary:        PyQt 5 devel
Group:          Development/Python
Requires:       %{name}
Requires:       qttools5-designer

%description devel
PyQt 5 devel utilities

%files devel
%{_bindir}/py*
%{_qt5_plugindir}/designer

%package examples
Summary:        PyQt 5 examples
Group:          Development/Python
BuildArch:      noarch

%description examples
PyQt 5 examples.

%files examples
%doc examples

%define py3_name python3-qt5

%package -n python3-qt5
Summary:        Python 3 bindings for Qt5
Group:          Development/Python

BuildRequires:  python3-devel
BuildRequires:  python3-sip-devel >= 4.16.6
BuildRequires:  python3-dbus

Provides:       python3-PyQt5 = %version-%release
Requires:       python3-dbus
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}

%description -n python3-qt5
Python 3 bindings for Qt5.

%files -n python3-qt5
%doc NEWS README LICENSE
%{python3_sitelib}/*
%{python3_sitearch}/*
%{_datadir}/python3-sip

%package -n    %{py3_name}-devel
Summary:       Python 3 bindings for PyQt 5 devel
Group:         Development/Python
Requires:      %{py3_name}
Requires:      python3-sip-devel >= 4.16.6
Requires:      python-qt5-devel
Provides:      python3-PyQt5-devel = %version-%release
Requires:      qttools5-designer

%description -n %{py3_name}-devel
Python 3 bindings for PyQt 5 devel utilities.
Files needed to build other bindings for C++ classes that inherit from any
of the Qt5 classes (e.g. KDE or your own).

%files -n %{py3_name}-devel
%{_bindir}/py*

%prep
%setup -qn PyQt5_gpl-%{version}
cp -a . %{py3dir}

%build
export PATH=%{_qt5_bindir}:$PATH

%{__python2} ./configure.py \
  --qsci-api \
  --assume-shared \
  --confirm-license \
  --no-timestamp \
  --debug \
  --verbose

sed -i -e "s,-fstack-protector,-fno-stack-protector,g" _Q*/Makefile
sed -i -e "s,^LIBS .*= ,LIBS = $(python-config --libs) ,g" Qt*/Makefile _Q*/Makefile dbus/Makefile
sed -i -e "s#^LFLAGS .*= #LFLAGS = %{ldflags} #g" Qt*/Makefile _Q*/Makefile pyrcc/Makefile designer/Makefile dbus/Makefile qmlscene/Makefile

%make

pushd %{py3dir}
%{__python3} configure.py \
  --sipdir=%{_datadir}/python3-sip/PyQt5 \
  --no-qsci-api \
  --assume-shared \
  --confirm-license \
  --no-timestamp \
  --debug \
  --verbose

sed -i -e "s,-fstack-protector,-fno-stack-protector,g" _Q*/Makefile
sed -i -e "s,^LIBS .*= ,LIBS = $(python3-config --libs) ,g" Qt*/Makefile _Q*/Makefile dbus/Makefile
sed -i -e "s#^LFLAGS .*= #LFLAGS = %{ldflags} #g" Qt*/Makefile _Q*/Makefile pyrcc/Makefile designer/Makefile dbus/Makefile qmlscene/Makefile

%make
popd

%install
### python3-qt5 install
pushd %{py3dir}
%makeinstall_std INSTALL_ROOT=%{buildroot} -C %{py3dir}
rm -fr %{buildroot}%{python3_sitearch}/PyQt5/uic/port_v2

# ensure .so modules are executable for proper -debuginfo extraction
for i in %{buildroot}%{python3_sitearch}/PyQt5/*.so %{buildroot}%{python3_sitelib}/dbus/mainloop/pyqt5.so ; do
chmod a+rx $i
done
popd

### python-qt5 install
%make_install INSTALL_ROOT=%{buildroot}
rm -fr %{buildroot}%{python2_sitearch}/PyQt5/uic/port_v3

# ensure .so modules are executable for proper -debuginfo extraction
for i in %{buildroot}%{python2_sitearch}/PyQt5/*.so %{buildroot}%{python2_sitelib}/dbus/mainloop/pyqt5.so ; do
chmod a+rx $i
done

### install pyuic5 wrapper to handle both/either python2/python3
rm -fv %{buildroot}%{_bindir}/pyuic5
install -p -m 0755 -D %{SOURCE1} %{buildroot}%{_bindir}/pyuic5
sed -i \
  -e "s|@PYTHON3@|%{__python3}|g" \
  -e "s|@PYTHON2@|%{__python2}|g" \
  %{buildroot}%{_bindir}/pyuic5

%changelog
* Fri Jun 15 2018 adrianomorselli <adrianomorselli> 5.10.1-1uplos2018
- update
- dropped %{name}-doc package
